#!/bin/bash
if [[ -n "$1" ]];
then
	tar -xzvf "$1" -C /lib/modules/ --wildcards --strip-components=3 "BPI-ROOT/lib/modules/*"

  kernelversion=$(tar -tzf "$1" | grep "lib/modules/[^/]\+/$" | sed 's/^.*\/\([0-9.]\+\)-bpi-r2.*$/\1/')
  echo $kernelversion

  kernelfile=/boot/bananapi/bpi-r2/linux/uImage
  dtbfile=/boot/bananapi/bpi-r2/linux/dtb/bpi-r2.dtb
  if [[ -e "${kernelfile}" ]];
  then
    echo "kernelfile exists, make backup";
    cp ${kernelfile} ${kernelfile}.bak
  fi
  if [[ -e "${kernelfile}_nodt" ]];
  then
    echo "kernelfile (no_dt) exists, make backup";
    cp ${kernelfile}_nodt ${kernelfile}_nodt.bak
  fi
  if [[ -e "${dtbfile}" ]];
  then
    echo "dtbfile exists, make backup";
    cp ${dtbfile} ${dtbfile}.bak
  fi

  tar -xzvf "$1" -C /boot/bananapi/bpi-r2/linux/ --wildcards --strip-components=4 BPI-BOOT/bananapi/bpi-r2/linux/*

  if [[ -e "${kernelfile}_${kernelversion}" ]];
  then
    echo "kernelfile (${kernelversion}) exists, make backup";
    cp ${kernelfile}_${kernelversion} ${kernelfile}_${kernelversion}.bak
  fi

  cp ${kernelfile} ${kernelfile}_${kernelversion}

  echo -n "by default this file will be loaded: "
  grep '^kernel=' /boot/bananapi/bpi-r2/linux/uEnv.txt | sed 's/^.*=//'
  echo "maybe you need to change this in uEnv.txt..."
else
	echo "no filename given..."
fi
